/*
** Copyright (c) 2001 PIXAR.  All rights reserved.  This program or
** documentation contains proprietary confidential information and trade
** secrets of PIXAR.  Reverse engineering of object code is prohibited.
** Use of copyright notice is precautionary and does not imply
** publication.
**
**                      RESTRICTED RIGHTS NOTICE
**
** Use, duplication, or disclosure by the Government is subject to the
** following restrictions:  For civilian agencies, subparagraphs (a) through
** (d) of the Commercial Computer Software--Restricted Rights clause at
** 52.227-19 of the FAR; and, for units of the Department of Defense, DoD
** Supplement to the FAR, clause 52.227-7013 (c)(1)(ii), Rights in
** Technical Data and Computer Software.
**
** Pixar
** 1200 Park Ave
** Emeryville, CA 94608
**
** ----------------------------------------------------------------------------
*/

/* code generated by slim 6.5.3, RAT 6.5.3 (May 15 2006 03:07:00) */
/* for jeremy@yuffie.outersquare.org at: Mon Apr 23 00:09:52 PDT 2007 */
/* shader modification timestamp: 1177312146 */

/* includes ---------------------------------*/
#include "pxslUtil.h"
/* defines ----------------------------------*/
#define SLIM_TYPEID_surface 0
#define SLIM_TYPEID_displacement 1
#define SLIM_TYPEID_volume 2
#define SLIM_TYPEID_light 3
#define SLIM_VERSION 650
#define SLIM_SHADERTYPE light
#define SLIM_SHADERTYPEID SLIM_TYPEID_light
#define SLIM_INSTANCETYPE light
#define SLIM_INSTANCENAME Spot

/* shader body ------------------------------*/
SLIM_SHADERTYPE
SLIM_INSTANCENAME (
  string ShadowMap_File="rmantex/shd/cornell_shadows_ShadowGen.spotLightShape1.shd.tex";
  float ConeAngle=30;
  float PenumbraAngle=5;
  output varying float __nondiffuse=1;
  output varying float __nonspecular=1;
  output varying color __inShadowC=color(0,0,0);
  output varying float _contribRim=1;
  output varying float _contribThinTranslucence=1;
  output varying float _contribBackScattering=1;
  output varying float _contribSubsurfaceScattering=1;
)
{

/* static functions ----------------------*/

		void pxslCurrentPoint (
		    uniform float frequency;
		    output varying point Q; 
		    output varying vector duQ;
		    output varying vector dvQ;
		) 
		{
		    extern point P, Ps;
		    extern float du, dv;
#if SLIM_SHADERTYPEID == SLIM_TYPEID_light
		    Q = frequency * Ps;
#else
		    Q = frequency * P;
#endif
		    duQ = Du(Q)*du;
		    dvQ = Dv(Q)*dv;
		}
	    

	    void
	    pxslCShadowMap(
	    	string filename;
		float samples;
		float blur;
		float bias;
		point Q;
		vector dQu;
		vector dQv;
		output color result; )
	    {
	    	if(filename == "")
		{
	    	    result = 0;
		}
		else
	    	if(bias != 0)
		{
		    result = color shadow(filename, Q,
		    	    	"samples", samples,
				"blur", blur,
				"bias", bias);
		}
		else
		{
		    result = color shadow(filename, Q,
		    	    	"samples", samples,
				"blur", blur);
		}
	    }
    	

/* dynamic functions ------------------------*/

/* local variables --------------------------*/
  color tmp3;
  point tmp0;
  vector tmp1;
  vector tmp2;

/* main body --------------------------------*/
  point from = point "shader"(0,0,0);
  vector axis = normalize(vector "shader"(0,0,1));
  uniform float angle = radians(ConeAngle);
  uniform float penumbra = radians(PenumbraAngle);
  uniform float cosoutside = cos(angle);
  uniform float cosinside = cos(angle-penumbra);
  __inShadowC = color(0);
  illuminate(from, axis, angle) {
    varying float atten, cosangle;
    cosangle = L.axis / length(L);
    atten = smoothstep( cosoutside, cosinside, cosangle );
    atten *= 1 / pow(length(L), 0);
    /* generate (all) ----------- */
    pxslCurrentPoint ( /* CurrentPoint */
      1, /* Frequency */
      tmp0, /* Q */ 
      tmp1, /* dQu */ 
      tmp2  /* dQv */ 
      );
    pxslCShadowMap ( /* ShadowMap */
      ShadowMap_File, /* File */
      16, /* Samples */
      0, /* Blur */
      0, /* Bias */
      tmp0, /* Q */ 
      tmp1, /* dQu */ 
      tmp2, /* dQv */ 
      tmp3  /* result */ 
      );
    __inShadowC = tmp3;
    __nondiffuse = 1 - 1;
    __nonspecular = 1 - 1;
    _contribRim = 1;
    _contribThinTranslucence = 1;
    _contribBackScattering = 1;
    _contribSubsurfaceScattering = 1;
    Cl = atten * 1 * color(0.000,0.000,0.000);
    Cl = pxslCmix(Cl, color(1.000,1.000,1.000), __inShadowC);
  }
}

